package de.mmt.mpeg.framework;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.UIManager;

import de.javafrog.gui.GuiUtil;
import de.mmt.mpeg.framework.gui.BlockRestorePanel;
import de.mmt.mpeg.framework.gui.BlockSearchPanel;
import de.mmt.mpeg.framework.gui.ConversionPanel;
import de.mmt.mpeg.framework.gui.MacroblockPanel;

public class MainWindow extends JFrame
{
private static final long serialVersionUID = 1L;

private JFrame f;

public static void main(String[] args)
  {
   try
     {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
     }
   catch (Exception e)
     {
      System.out.println("Konnte systemspezifisches Look&Feel nicht initialisieren.");
     }   
   
   new MainWindow().getFrame().setVisible(true);
  }

protected JFrame getFrame()
  {
   this.f = new JFrame("Medien und Medienstrme, Aufgabe 3: MPEG");
   f.add(this.getMainPanel());
   f.setSize(f.getPreferredSize());
   GuiUtil.centerWindowOnScreen(f);
   f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
       
   return f;
  }

protected JPanel getMainPanel()
  {
   JPanel p = new JPanel();
   p.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
   p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
   JTabbedPane tab = new JTabbedPane();

   tab.addTab("Konvertierung RGB > YCbCr",GuiUtil.createImageIcon("/images/color_wheel.png",""),new ConversionPanel(),"Konvertiert ein Bild aus dem RGB-Farbraum in YCbCr.");
   tab.addTab("Makroblockbildung",GuiUtil.createImageIcon("/images/bricks.png",""),new MacroblockPanel(),"Erzeugt aus einem Bild eine abspeicherbare Makroblockdatei.");
   tab.addTab("Blocksuche",GuiUtil.createImageIcon("/images/zoom.png",""),new BlockSearchPanel(),"Erzeugt aus zwei Bildern einen Differenzframe, der als Makroblockdatei gespeichert werden kann.");
   tab.addTab("Blockprfung",GuiUtil.createImageIcon("/images/accept.png",""),new BlockRestorePanel(),"Stellt eine Makroblockdatei wieder als Bild dar.");
   
   p.add(tab);   
   return p;
  }
}